'''
Created on 2 Sep 2009

@author: jamie
'''
import Actor
import Box2D
import DebugDraw

class TriggerActor(Actor.Actor):
    
    triggerShape = None
    triggerCallback = None
    callbackArgs = None
    
        
    def __init__(self, pos, points, world, debugDraw, onTriggeredCallback, callbackArgs):        
        ''' Create a non-collidable trigger from a list of points'''     
        triggerBodyDef = Box2D.b2BodyDef()
        triggerBodyDef.position = pos        
        triggerBody = world.CreateBody(triggerBodyDef)        
        
        triggerShapeDef = Box2D.b2PolygonDef()
        triggerShapeDef.vertexCount = len(points)
        triggerShapeDef.setVertices(points)
        triggerShapeDef.isSensor = True
        triggerShapeDef.filter.categoryBits = Actor.CollisionGroup.trigger
        triggerShapeDef.filter.maskBits = Actor.CollisionGroup.icarus
                
        self.triggerShape = triggerBody.CreateShape(triggerShapeDef)
        
        self.triggerCallback = onTriggeredCallback
        self.callbackArgs = callbackArgs
                

        # Call the base constructor, with our body
        super(TriggerActor, self).__init__(triggerBody, debugDraw, world)

    def HandleTouchedByIcarus(self, icarus):
        self.triggerCallback(self.callbackArgs)
