'''
Created on 1 Sep 2009

@author: jamie
'''

import Actor
import Box2D
import DebugDraw

class WallActor(Actor.Actor):
        
    def __init__(self, pos, points, world, debugDraw):        
        ''' Create a collideable wall from a list of points'''     
        wallBodyDef = Box2D.b2BodyDef()
        wallBodyDef.position = pos        
        wallBody = world.CreateBody(wallBodyDef)        
        
        wallShapeDef = Box2D.b2PolygonDef()
        wallShapeDef.vertexCount = len(points)
        wallShapeDef.setVertices(points)
        wallShapeDef.friction = 1
        wallShapeDef.filter.categoryBits = Actor.CollisionGroup.wall
        wallShapeDef.filter.maskBits = Actor.CollisionGroup.icarus | Actor.CollisionGroup.bird | Actor.CollisionGroup.birdsensor | Actor.CollisionGroup.feather | Actor.CollisionGroup.bullet
                
        wallBody.CreateShape(wallShapeDef)        

        # Call the base constructor, with our body
        super(WallActor, self).__init__(wallBody, debugDraw, world)
